open Graphics;;

(* a button and its associated functions *)
class button x y w h m c =
 object
  val b_x = x
  val b_y = y
  val b_w = w
  val b_h = h
  val b_m = m
  val b_c = c

  method pos mouse_status =
    let x = mouse_status.mouse_x in
    let y = mouse_status.mouse_y in
    (b_x < x) & (x < (b_x + b_w)) &
    (b_y < y) & (y < (b_y + b_h))

  method draw =
    begin
      set_color b_c;
      fill_rect b_x b_y b_w b_h;
      moveto (b_x + 8) (b_y + (b_h / 2));
      set_color black;
      draw_string b_m
    end
end;;

    
(* the universe *)
class universe x y w h =
 object
  val u_x = x
  val u_y = y
  val u_w = w
  val u_h = h

  method plot color radius x y = 
    if (u_x < x-radius) & (x+radius < u_x + u_w) &
      (u_y < y-radius) & (y+radius < u_y + u_h)
    then 
      begin
      	set_color color;
      	fill_circle x y radius;
      end

  method pos mouse_status =
      let x = mouse_status.mouse_x in
      let y = mouse_status.mouse_y in
      (u_x < x) & (x < (u_x + u_w)) &
      (u_y < y) & (y < (u_y + u_h))

  (* the reaction of the border *)
  method border x y dx dy =
    let l = (truncate x) <= u_x
    and r = (truncate x) >= u_x + u_w
    and u = (truncate y) >= u_y + u_h
    and d = (truncate y) <= u_y in
    if u or d then if l or r then -.dx,-.dy else dx,-.dy
    else if l or r then -.dx,dy else dx,dy

  method draw =
    begin
      set_color black;
      moveto u_x u_y;
      lineto (u_x+u_w) u_y;
      lineto (u_x+u_w) (u_y+u_h);
      lineto u_x (u_y+u_h);
      lineto u_x u_y
    end

  method clear =
    begin
      set_color background;
      fill_rect (u_x+1) (u_y+1) (u_w-2) (u_h-2)
    end
end;;
