.TH LUCYC 1

.SH NAME
lucyc \- The Lucid Synchrone compiler, version 1.01


.SH SYNOPSIS
.B lucyc
[
.B \-civ
]
[
.BI \-I \ lib-dir
]
[
.BI \-O \ module
]
[
.BI \-s \ node
]
[
.BI \-realtime
]
[
.BI \-sampling \ rate
]
[
.BI \-stdlib
]
.I filename ...


.SH DESCRIPTION

.B lucyc
is a compiler for Lucid Synchrone, a synchronous data-flow language
combining the synchrony of Lustre and the functionality of ML. Lucid
Synchrone is built on top of Objective Caml.

.B lucyc
accepts two kinds of arguments: 

Arguments ending in .ls are considered
to be Lucid Synchrone source files. A file .ls is a sequence of node
declarations. From a file 
.IR f \&.ls,
the 
.B lucyc
compiler produces an Ojective caml file 
.IR f \&.ml
and a compiled interface
.IR f \&.lzi.

Arguments inding in .mli are considered to be Objective Caml
interface files. From a file f.mli, the 
.B lucyc
compiler produces a
compiled interface 
.IR f \&.lzi.
Every value defined in 
.IR f \&.mli 
is considered to be a scalar value.

The following options are accepted by the lucyc command:
.SH OPTIONS

.TP
.B \-c
Compile only. Produces a file ending in .ml defining the corresponding
transition functions of the nodes defined in the input file.
.TP
.BI \-I \ lib-dir
Adds
.I lib-dir 
to the path of directories searched for compiled interface files .lzi.
.TP
.BI \-O \ module
Firt opens the module 
.IR module \&.
.TP
.BI \-i 
Print types and clocks.
.TP
.BI \-s \ node
Produces a file 
.IR node \&.ml, 
simulating the main node
.IR node \&.
.TP
.BI \-sampling \ rate
Sets the sampling rate to
.I rate
seconds for sampling the simulation node.
.TP
.B \-realtime
Real-time mode of the compiler. Only non recursive nodes (and not dynamic nodes) are allowed.
.TP
.B \-v
Prints the compiler version number.



.SH RESTRICTIONS

The following restrictions apply to the current implementation (version 1.01):

.TP

.TP
.B Compilation
The unary 
.I pre
operator should be applied to expressions of monomorphic type.

.SH FILES

.ta 3.5i
/usr/local/bin/lucyc	the compiler

/usr/local/lib/lucid-synchrone	the standard library
