.TH LUCYS 1

.SH NAME 
lucys \- The Lucid Synchrone Simulator

.SH SYNOPSIS
.B lucys
[
.B \-x
]
[
.B \-s
]
.I node
.I filename

.SH DESCRIPTION

.B lucys
is a simulator for the Lucid Synchrone programming language (see 
.B lucyc
). 

.B lucys
produce a binary 
.I node
which simulate the node defined in
.I filename. 

.B lucys
can produce two types of program: a text-mode version and an
X version. The text-mode is the default mode.

.I node
is the name of the node to simulate.
.I filename 
is taken to be either a source file (with suffix .ls),
a compiled interface (with suffix .lzi) or a basename. If it's a source file, the file will first be compiled by
.B lucyc
and if it's a basename the file will be compiled only if required.

The clock of the inputs and output are respected. In the text-mode
version an input will be asked only when necessary, imposing a
restriction on the order of the input (see RESTRICTIONS below), in
the X version, an input is always present but will be used only on its
clock. In both version the output is printed only on its clock. 

The X version provides some facilities. The "step" button can be
switched on "autostep" in which mode the boolean inputs can be used to
take the step. The "reset" button is used to reset the node, which
gets back to its initial state.

The graphic window of the simulator is organised as follows, on the top left we have the inputs, on the top right the outputs and on the bottom the control buttons. Each input and each output is represented by one button. The presentation of the buttons follows the tree structure of the node's type.

.SH OPTIONS
.TP
.B \-x
simulates in graphic mode (X-window). 
.TP
.B \-s
Produces a Lucid Synchrone file 
.I node__sim.ls
containing the code of the simulator. This file may in turn be
compiled with the
.I lucyc
command.

.SH RESTRICTIONS

In the current implementation the following restrictions apply :

.TP
.B Types :
Only the primitives types can be simulated, that is bool, int, float, string, float and types made of those.

node with a polymorphic type can not be simulated. 

.TP
.B Clocks :
when a node takes several inputs on different clocks, the clock of an input must only depend of a preceding input.

.SH BUGS

hehe


.SH SEE ALSO
.B lucyc
(1)


